/*
 *  GOL - Game of life simulation software
 *  Copyright (C) 1996 Michael Raymond Brown
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 *  Author: Michael Raymond Brown
 *  EMail:  michael@arrakeen.demon.co.uk
 *  WWW:    http://www.arrakeen.demon.co.uk/
 *  Address:  Michael Brown
 *            Kia Ora
 *            Brook Street
 *            Great Bromley
 *            Nr Colchester
 *            Essex
 *            CO7 7HX
 *            England
 */


#ifdef __GNUC__
#pragma implementation
#endif

#include "Core.h"
#include "Widget.h"
#include <string.h>


xwCore::xwCore()
   {remove_count=0;
    widget_count=0;
    array_length=0;
    widgets=(xwWidget**)0;
   }
xwCore::~xwCore()
   {
   }


void xwCore::addWidget(xwWidget* widget)
   {if (widget_count == array_length)
       {xwWidget** temp;
	if (widgets)
	     array_length*= 2;
	else array_length = 4;
	temp = new xwWidget*[array_length];
	memset(temp, 0, sizeof(xwWidget*)*array_length);
	if (widgets)
	   {memcpy(temp, widgets, sizeof(xwWidget*)/2*array_length);
	    delete [] widgets;
	   }
	widgets = temp;
       }
    widgets[widget_count++]=widget;
   }
void xwCore::removeWidget(xwWidget* widget)
   {int count;

    for (count=widget_count; count--; )
     if (widgets[count] == widget)
	{widgets[count]=(xwWidget*)0;
	 remove_count++;
	 break;
	}

    if (remove_count > 4)
       {for (count=widget_count=0; count<array_length; count++)
	     if (widgets[count]) widgets[widget_count++]=widgets[count];
	remove_count=0;
       }
   }
xwWidget* xwCore::findWidget()
   {int   count;
    xwWidget* w;
    for (count=widget_count; count--; )
	 if (w=widgets[count]) return w;
    return (xwWidget*)0;
   }

void xwCore::destroyWidgets()
   {xwWidget* widget;
    while (widget = findWidget())
	  {
	   removeWidget(widget);
	   delete widget;
	  }
   }


