/*
 *  GOL - Game of life simulation software
 *  Copyright (C) 1996 Michael Raymond Brown
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 *  Author: Michael Raymond Brown
 *  EMail:  michael@arrakeen.demon.co.uk
 *  WWW:    http://www.arrakeen.demon.co.uk/
 *  Address:  Michael Brown
 *            Kia Ora
 *            Brook Street
 *            Great Bromley
 *            Nr Colchester
 *            Essex
 *            CO7 7HX
 *            England
 */


#ifdef __GNUC__
#pragma implementation
#endif

#include <stdlib.h>
#include "GC.h"

xwGC::xwGC()
   {
   }
xwGC::~xwGC()
   {
   }

void xwGC::line(int x1, int y1, int x2, int y2, int colour)
   {int w = abs(x2-x1)+1;
    int h = abs(y2-y1)+1;

    if (w > h) {
	int yval = 0-w;
	int yadd = h;
	int ysub = w;
	int ydiff = y2 > y1 ? 1 : -1;
	int xdiff = x2 > x1 ? 1 : -1;
	do {plot(x1, y1, colour);
	    yval+=yadd;
	    if (yval >= 0)
	       {yval-=ysub;
		y1+=ydiff;
	       }
	    x1+=xdiff;
	} while (--w);
    } else {
	int xval = 0-h;
	int xadd = w;
	int xsub = h;
	int ydiff = y2 > y1 ? 1 : -1;
	int xdiff = x2 > x1 ? 1 : -1;
	do {plot(x1, y1, colour);
	    xval+=xadd;
	    if (xval >= 0)
	       {xval-=xsub;
		x1+=xdiff;
	       }
	    y1+=ydiff;
	} while (--h);
   }}

void xwGC::multiPlot(int x, int y, int w, int h, const int* pixels, int scan_w)
   {scan_w-=w;
    if (w && h) do {
	int tw = w;
	do {plot(x, y, *pixels);
	    pixels++;
	    x++;
	} while (--tw);
	pixels+=scan_w;
	x-=w;
	y++;
    } while (--h);
   }
void xwGC::multiPlot(int x, int y, int w, int h, const int* pixels)
   {multiPlot(x, y, w, h, pixels, w);
   }

void xwGC::multiPoint(int x, int y, int w, int h, int* pixels, int scan_w)
   {scan_w-=w;
    if (w && h) do {
	int tw = w;
	do {*pixels=point(x, y);
	    pixels++;
	    x++;
	} while (--tw);
	pixels+=scan_w;
	x-=w;
	y++;
    } while (--h);
   }
void xwGC::multiPoint(int x, int y, int w, int h, int* pixels)
   {multiPoint(x, y, w, h, pixels, w);
   }


